var app = angular.module('Firma', [])
    .config(function($locationProvider,$httpProvider) {
        $locationProvider.html5Mode(true);
        $locationProvider.html5Mode(true).hashPrefix('!');
        //Reset headers to avoid OPTIONS request (aka preflight)
        $httpProvider.defaults.headers.common = {};
        $httpProvider.defaults.headers.post = {};
        $httpProvider.defaults.headers.put = {};
        $httpProvider.defaults.headers.patch = {};

    });

app.directive('modal', function () {
    return {
        template: '<div class="modal fade">' +
        '<div class="modal-dialog" id="dialogo" style="width: {{docmodalwidth}}px; padding: 20px">' +
        '<div class="modal-content">' +
        '<div class="modal-header" style="padding: 10px">' +
        '<button class="btn btn-sm btn-primary pull-right" style="height:44px" ng-click="salva()">OK</button>' +
        '<button class="btn btn-sm btn-warning pull-right" style="height:44px" ng-click="chiudi()">Cancel</button>' +
        '<button class="btn btn-sm btn-warning pull-left" style="height:44px" ng-click="puliscifirma()">Pulisci</button>' +
        '<h4 class="modal-title">{{ title }}</h4>' +
        '</div>' +
        '<div class="modal-body" style="height: 230px; padding: 5px" ng-transclude></div>' +
        '<div class="modal-footer" style="padding: 5px">' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>',
        restrict: 'E',
        transclude: true,
        replace:true,
        scope:true,
        link: function postLink(scope, element, attrs) {
            scope.title = attrs.title;

            scope.$watch(attrs.visible, function(value) {
                if ($(element)) {

                if (value == true)
                    $(element).modal('show');
                else

                    $(element).modal('hide');
                }
            });

            $(element).on('shown.bs.modal', function(){
                scope.$apply(function(){
                    scope.$parent[attrs.visible] = true;
                });
            });

            $(element).on('hidden.bs.modal', function(){
                scope.$apply(function(){
                    scope.$parent[attrs.visible] = false;
                });
            });
        }
    };
});
app.controller('FirmaCtrl', function($scope, $http, $location){

    var changeLocation = function(url, forceReload) {
        $scope = $scope || angular.element(document).scope();
        if(forceReload || $scope.$$phase) {
            window.location = url;
        }
        else {
            //only use this if you want to replace the history stack
            //$location.path(url).replace();

            //this this if you want to change the URL and add it to the history stack
            $location.path(url);
            $scope.$apply();
        }
    };

	$scope.goHome=function(){
        changeLocation('index.html?ip=' + $scope.ipchiamante, true);
    }

    $scope.goHomeHo=function(){
        changeLocation('http://studio.caes.it/index.html?ip=' + $scope.iporigine, true);
    }

    $scope.init=function(){
        //?id=BBBAAA69609029
        $scope.curIdPaz= $location.search()["id"];
        $scope.pg= $location.search()["pg"];
        $scope.fi=$location.search()["fi"];
        $scope.iporigine=$location.host();
    }

    $scope.initfirma = function(){
        $scope.ipchiamante=$location.search()["ip"];
        $scope.fi=$location.search()["fi"];
        $scope.iporigine=$location.host();

        $scope.canvas=    document.getElementById("canvas");
        $scope.canvasContext= $scope.canvas.getContext("2d");

        var sizedWindowWidth = window.innerWidth;
        //if(sizedWindowWidth > 700)
        //    sizedWindowWidth = window.innerWidth / 2;
        //else if(sizedWindowWidth > 400)
        //    sizedWindowWidth = sizedWindowWidth - 100;
        //else
        //    sizedWindowWidth = sizedWindowWidth - 50;


        $scope.canvas.height = 200;
        $scope.canvas.width = sizedWindowWidth -50;


        if($scope.canvasContext) {
            $scope.canvasContext.canvas.width = $scope.canvas.width;
            $scope.canvasContext.canvas.height = 200;
        }

        var isTouchDevice = !!("ontouchstart" in window);
        if (isTouchDevice) {
            var drawer = {
                isDrawing: false,
                touchstart: function(coors){
                    $scope.canvasContext.beginPath();
                    $scope.canvasContext.moveTo(coors.x, coors.y);
                    $scope.canvasContext.arc(coors.x, coors.y, 0.5, 0, 2 * Math.PI);
                    $scope.canvasContext.stroke();
                    this.isDrawing = true;
                },
                touchmove: function(coors){
                    if (this.isDrawing) {
                        $scope.canvasContext.lineTo(coors.x, coors.y);
                        $scope.canvasContext.stroke();
                    }
                },
                touchend: function(coors){
                    if (this.isDrawing) {
                        this.touchmove(coors);
                        $scope.canvasContext.closePath();
                        this.isDrawing = false;
                    }
                }
            };
            // create a function to pass touch events and coordinates to drawer
            function draw(event){
                // get the touch coordinates
                var coors = {
                    x : event.targetTouches[0].pageX - $(event.target).offset().left,
                    y : event.targetTouches[0].pageY - $(event.target).offset().top
                };
                // pass the coordinates to the appropriate handler
                drawer[event.type](coors);
            }

            $scope.canvas.addEventListener('touchstart',draw, false);
            $scope.canvas.addEventListener('touchmove',draw, false);
            $scope.canvas.addEventListener('touchend',draw, false);

            // prevent elastic scrolling
            document.body.addEventListener('touchmove',function(event){
                event.preventDefault();
            },false);

        }else {
            $scope.canvas.onmousedown = function (e) {
                if (e.which === 1) {
                    $scope.ismove=false;
                    $scope.leftMButtonDown = true;
                    $scope.canvasContext.fillStyle = "#000";
                    var x = e.pageX - $(e.target).offset().left;
                    var y = e.pageY - $(e.target).offset().top;
                    $scope.canvasContext.beginPath();
                    $scope.canvasContext.moveTo(x, y);
                    $scope.canvasContext.stroke();
                }
                e.preventDefault();
                return false;
            };

            $scope.canvas.onmouseup = function (e) {
                if ($scope.leftMButtonDown && e.which == 1) {
                    if (!$scope.ismove){
                        var x = e.pageX - $(e.target).offset().left;
                        var y = e.pageY - $(e.target).offset().top;
                        $scope.canvasContext.arc(x, y, 1, 0, 2 * Math.PI);
                        $scope.canvasContext.arc(x, y, 1, 1, 2 * Math.PI);
                        $scope.canvasContext.arc(x, y, 1, 2, 2 * Math.PI);
                        $scope.canvasContext.stroke();
                    }
                    $scope.leftMButtonDown = false;
                    $scope.canvasContext.closePath();
                }
                e.preventDefault();
                return false;
            };

            // draw a line from the last point to this one
            $scope.canvas.onmousemove = function (e) {
                if ($scope.leftMButtonDown == true) {
                    $scope.ismove=true;
                    $scope.canvasContext.fillStyle = "#000";
                    var x = e.pageX - $(e.target).offset().left;
                    var y = e.pageY - $(e.target).offset().top;
                    $scope.canvasContext.lineTo(x, y);
                    $scope.canvasContext.stroke();
                }
                e.preventDefault();
                return false;
            };
        }
    }

    $scope.avviafirma = function(){
        $scope.canvas=    document.getElementById("canvas");
        $scope.canvasContext= $scope.canvas.getContext("2d");

        var sizedWindowWidth = window.innerWidth;
        //if(sizedWindowWidth > 700)
        //    sizedWindowWidth = window.innerWidth / 2;
        //else if(sizedWindowWidth > 400)
        //    sizedWindowWidth = sizedWindowWidth - 100;
        //else
        //    sizedWindowWidth = sizedWindowWidth - 50;

        $scope.docmodalwidth=sizedWindowWidth;

        $scope.canvas.height = 200;
        $scope.canvas.width = sizedWindowWidth -50;


        if($scope.canvasContext) {
            $scope.canvasContext.canvas.width = $scope.canvas.width;
            $scope.canvasContext.canvas.height = 200;
        }

        $scope.showModal = !$scope.showModal;
        $scope.docmodal=    document.getElementById("dialogo");
        //var canvas =document.getElementById("canvas");
        //$scope.canvasContext=canvas.getContext("2d");


        var isTouchDevice = !!("ontouchstart" in window);
        if (isTouchDevice) {
            var drawer = {
                isDrawing: false,
                touchstart: function(coors){
                    $scope.canvasContext.beginPath();
                    $scope.canvasContext.moveTo(coors.x, coors.y);
                    $scope.canvasContext.arc(coors.x, coors.y, 0.5, 0, 2 * Math.PI);
                    $scope.canvasContext.lineWidth = 3;
                    $scope.canvasContext.stroke();
                    this.isDrawing = true;
                },
                touchmove: function(coors){
                    if (this.isDrawing) {
                        $scope.canvasContext.lineTo(coors.x, coors.y);
                        $scope.canvasContext.lineWidth = 3;
                        $scope.canvasContext.stroke();
                    }
                },
                touchend: function(coors){
                    if (this.isDrawing) {
                        this.touchmove(coors);
                        $scope.canvasContext.closePath();
                        this.isDrawing = false;
                    }
                }
            };
            // create a function to pass touch events and coordinates to drawer
            function draw(event){
                // get the touch coordinates
                var coors = {
                    x : event.targetTouches[0].pageX - $(event.target).offset().left,
                    y : event.targetTouches[0].pageY - $(event.target).offset().top
                };
                // pass the coordinates to the appropriate handler
                drawer[event.type](coors);
            }

            $scope.canvas.addEventListener('touchstart',draw, false);
            $scope.canvas.addEventListener('touchmove',draw, false);
            $scope.canvas.addEventListener('touchend',draw, false);

            // prevent elastic scrolling
            document.body.addEventListener('touchmove',function(event){
                event.preventDefault();
            },false);

        }else {
            $scope.canvas.onmousedown = function (e) {
                if (e.which === 1) {
                    $scope.ismove=false;
                    $scope.leftMButtonDown = true;
                    $scope.canvasContext.fillStyle = "#000";
                    var x = e.pageX - $(e.target).offset().left;
                    var y = e.pageY - $(e.target).offset().top;
                    $scope.canvasContext.beginPath();
                    $scope.canvasContext.moveTo(x, y);
                    $scope.canvasContext.lineWidth = 3;
                    $scope.canvasContext.stroke();
                }
                e.preventDefault();
                return false;
            };

            $scope.canvas.onmouseup = function (e) {
                if ($scope.leftMButtonDown && e.which == 1) {
                    if (!$scope.ismove){
                        var x = e.pageX - $(e.target).offset().left;
                        var y = e.pageY - $(e.target).offset().top;
                        $scope.canvasContext.arc(x, y, 1, 0, 2 * Math.PI);
                        $scope.canvasContext.arc(x, y, 1, 1, 2 * Math.PI);
                        $scope.canvasContext.arc(x, y, 1, 2, 2 * Math.PI);
                        $scope.canvasContext.lineWidth = 3;
                        $scope.canvasContext.stroke();
                    }
                    $scope.leftMButtonDown = false;
                    $scope.canvasContext.closePath();
                }
                e.preventDefault();
                return false;
            };

            // draw a line from the last point to this one
            $scope.canvas.onmousemove = function (e) {
                if ($scope.leftMButtonDown == true) {
                    $scope.ismove=true;
                    $scope.canvasContext.fillStyle = "#000";
                    var x = e.pageX - $(e.target).offset().left;
                    var y = e.pageY - $(e.target).offset().top;
                    $scope.canvasContext.lineTo(x, y);
                    $scope.canvasContext.lineWidth = 3;
                    $scope.canvasContext.stroke();
                }
                e.preventDefault();
                return false;
            };
        }
    }

    var inviafirma=function(data){
        if(!$scope.pg){
            $scope.pg=0;
        }
        $http.post('documenti/firma.json?id='+ $scope.curIdPaz+'&pg='+$scope.pg,data) //la chiamata json dovrà avere il codice_cliente come parametro
            .success(function(response) {
				$scope.chiudi() ;

            }).error(function(data, status) {
                alert( "Errore: " + JSON.stringify({data: data}));
				$scope.chiudi() ;
            });

    }

    $scope.inviasolofirma=function(){
        var data=$scope.canvas.toDataURL();
        $http.post('http://'+$scope.ipchiamante+':9000/firma/firma.json',data) //la chiamata json dovrà avere il codice_cliente come parametro
            .success(function(response) {
                $scope.puliscifirma();
            }).error(function(data, status) {
                alert( "Errore: " + JSON.stringify({data: data}));
            });
    }

    $scope.salva=function() {
        $scope.imgData = $scope.canvas.toDataURL();
        inviafirma($scope.imgData);
    }

    $scope.chiudi=function() {
        $scope.canvasContext.clearRect ( 0 , 0 , $scope.canvas.width, $scope.canvas.height );
        $scope.showModal = false;

        var isTouchDevice = !!("ontouchstart" in window);
        if (isTouchDevice) {
			window.location.href=window.location.href;
		}
    }

    $scope.puliscifirma = function(){
        $scope.imgData = "";
        $scope.canvasContext.clearRect ( 0 , 0 , $scope.canvas.width, $scope.canvas.height );
    }

});
